import React,{Component} from "react";
import {View,Icon} from '@tarojs/components'
import {AtButton} from "taro-ui";
import './index.less';
import Taro from "@tarojs/taro";

class Result extends Component{
  constructor(props) {
    super(props);
    this.determine= this.determine.bind(this);
  }

  determine(){
    Taro.eventCenter.trigger('result')
  }

  render() {
    return(
      <View className='result'>
        <View className='resultIcon'>
          {
            this.props.resultState === 0 ?
              <Icon size='80' type='success' /> :
              this.props.resultState === 43101 ?
                <Icon size='80' type='info' /> :
                <Icon size='80' type='warn' />
          }
        </View>
        <View className='resultTitle'>
          {
            this.props.resultState === 0 ?
              '申请成功' :
              this.props.resultState === 43101 ?
                '申请成功,但您的上级未打开订阅消息通知,请与上级联系,否则审批可能会不及时' :
                '申请成功,消息发送错误,请联系管理员'
          }
          {
            this.props.resultState !== 0 && this.props.resultState !== 43101 ?
              <View className='resultError'>错误编码:{this.props.resultState}</View>:null
          }
        </View>
        <View className='resultOperation'>
          <AtButton type='primary' circle onClick={this.determine}>
            确定
          </AtButton>
        </View>
      </View>
    )
  }
}

export default Result;
